﻿using System;
using System.Collections.Generic;
using System.Text;
using Windows.Foundation;

namespace Windows.UI.Xaml
{
	/// <summary>
	/// Class that holds virtualization information. We do not create this class indiscriminately, but only
	// for containers that happen to be virtualizing.
	/// </summary>
	internal sealed class VirtualizationInformation
	{
		/// <summary>
		/// Marks this as a container generated by, eg, a <see cref="Controls.Primitives.Selector"/>, rather than an element explicitly 
		/// defined in xaml.
		/// </summary>
		public bool IsGeneratedContainer { get; set; }

		/// <summary>
		/// Marks this as a container defined in the root of an ItemTemplate, so that it can be handled appropriately when recycled.
		/// </summary>
		public bool IsContainerFromTemplateRoot { get; set; }

		public Rect Bounds { get; set; }
	}
}
