namespace Windows.UI.ViewManagement
{
	/// <summary>
	/// Defines constants that specify known system color values.
	/// </summary>
	public enum UIColorType
	{
		/// <summary>
		/// The background color.
		/// </summary>
		Background,

		/// <summary>
		/// The foreground color.
		/// </summary>
		Foreground,

		/// <summary>
		/// The darkest accent color.
		/// </summary>
		AccentDark3,

		/// <summary>
		/// The darker accent color.
		/// </summary>
		AccentDark2,

		/// <summary>
		/// The dark accent color.
		/// </summary>
		AccentDark1,

		/// <summary>
		/// The accent color.
		/// </summary>
		Accent,

		/// <summary>
		/// The light accent color.
		/// </summary>
		AccentLight1,

		/// <summary>
		/// The lighter accent color.
		/// </summary>
		AccentLight2,

		/// <summary>
		/// The lightest accent color.
		/// </summary>
		AccentLight3,

		/// <summary>
		/// Not supported. Do not use.
		/// </summary>
		Complement,
	}
}
